"""
This module provides the class Class
"""
from ctypes import c_void_p
from coupy.method import Method

def fileheader_py(fout, imports, import_root, main_name):
    """
    Write the first lines (the 'file header') to a
    Python file.  The file header includes the various imports.
    """
    fout.write('import numpy as np # noqa\n')
    fout.write('from ctypes import c_double, c_int, c_long, c_size_t # noqa\n')
    for line in imports:
        fout.write(line+"# noqa\n")
    if import_root is None:
        fout.write('from generated.'+main_name+' import dll, runtime_error #noqa\n')
    else:
        fout.write('from '+import_root+'.generated.'+main_name+' import dll, runtime_error #noqa\n')
    fout.write('from coupy.coupling import is_c_string, is_ndarray #noqa\n\n\n')

class Class():
    """!
    Definition of the class Class, which represents a C++ class
    (and after C++ouPy is done, the corresponding Python class).
    """

    def __init__(self, my_dict, verbose_allocation=False):
        """
        Constructor of the class Class, initialized by the
        dict that contains its description.
        The optional argument verbose_allocation causes extra code in the
        generated C-code, that prints a message every time an allocation
        or a deallocation is done, as a diagnostic help.
        """
        self._dict = my_dict
        self._verbose_allocation = verbose_allocation

    def args_and_restype(self, dll):
        """!
        Fill in the types of arguments and return value for all the methods and
        functions.

        This function is called once after loading the DLL. After this, the
        methods and functions in the DLL can only be called with the correct number
        and type of arguments.
        """
        class_name = self._dict['class']

        getattr(dll, class_name+'_delete').argtypes = [c_void_p]

        # 'Create': the constructor
        create_dict = {'name': 'Create', 'input': self._dict['create']}
        Method( class_name, create_dict).set_args_and_restype(dll)

        for method in [Method(class_name, m) for m in self._dict['methods']]:
            method.set_args_and_restype(dll)

    def write_cpp(self, fout, hfile=False):
        """
        Write the contents of a class to the generated cpp file or the header file.
        """
        class_name = self._dict['class']
        fout.write("\n")
        fout.write('#include "C++ouPy.h"\n\n')
        fout.write('#include "'+class_name+'.h"\n')

        create_dict = {'name': 'Create', 'input': self._dict['create']}
        if 'body' in self._dict:
            create_dict['body'] = self._dict['body']
        Method(class_name, create_dict).write_cpp(fout, hfile, self._verbose_allocation)

        for method in [Method(class_name,m) for m in self._dict['methods']]:
            method.write_cpp(fout, hfile)
        if hfile:
            fout.write('    extern "C" void %s_delete(%s *C);\n' % (class_name,class_name))
        else:
            fout.write("void %s_delete(%s *C){\n" % (class_name,class_name))
            if self._verbose_allocation:
                fout.write('    printf("deleting %s at %s\\n",(void*) C);\n' % (class_name,'%p'))
            fout.write(    "    delete C;\n}\n")

    def header_py(self, fout):
        """
        Write the first lines (the 'header') of the class definition to the
        Python file that makes the C++ class available
        in Python. The header includes the destructor function __del__.
        """
        classname = self._dict['class']
        fout.write('class '+classname+'C():\n')
        fout.write('    """!\n')
        fout.write('    Python-Class for '+classname+' objects\n')
        fout.write('    This class was generated by C++ouPy.\n')
        fout.write('    This python-code makes available what is defined in\n')
        fout.write('    ['+classname+'](class'+classname+'.html)\n')
        fout.write('    """\n')
        fout.write('\n')
        fout.write('    def __del__(self):\n')
        fout.write('        if self._Cmine:\n')
        fout.write('            dll.%s_delete(self._C)\n' % classname)
        fout.write('\n')

    def init_py(self, fout):
        """
        Write the constructor to the Python file
        """
        create_dict = {'name': 'Create', 'input': self._dict['create']}
        classname = self._dict['class']
        Method(classname, create_dict).write_py(fout)

    def methods_py(self, fout):
        """
        Write the Class's methods to the Python file
        """
        for method in self._dict['methods']:
            Method(self._dict['class'], method).write_py(fout)


    def write_py(self, connection, main_name, fout):
        """
        Write the Python-file that creates a Python-class offering the functionalities of
        the C++ class
        """
        fileheader_py( fout,
                       connection['imports'] if 'imports' in connection else [],
                       connection['import_root'] if 'import_root' in connection else None,
                       main_name)
        self.header_py(fout)
        self.init_py(fout)
        self.methods_py(fout)
